
import knižnica.*;

public class Lopta extends GRobot
{
	public Lopta()
	{
		ohranič(ODRAZ);
		hrúbkaČiary(2);
		farba(zelená);
		zdvihniPero();
		náhodnýSmer();
		maximálnaRýchlosť(14);
		zrýchlenie(1, false);
		vypĺňajTvary();
		skry();
	}

	public void reset()
	{
		rýchlosť(0);
		náhodnýSmer();
		if (smer() >= 170 && smer() <= 190) vľavo(45);
		else if (smer() <= 10 || smer() >= 350) vpravo(45);
		skočNa(stred);
		aktivuj();
	}

	@Override public void kresliTvar()
	{
		krúžok();
	}

	@Override public void aktivácia()
	{
		zobraz();
	}

	@Override public void deaktivácia()
	{
		skry();
	}

	@Override public boolean koliduje(GRobot objekt)
	{
		if (objekt instanceof Plošina)
		{
			//## Plošina plošina = (Plošina)objekt;
			return objekt.bodVElipse(this,
				objekt.veľkosť() * 0.2 + veľkosť(),
				objekt.veľkosť() + veľkosť());
		}
		else if (objekt instanceof Tehla)
		{
			//## Tehla tehla = (Tehla)objekt;
			return objekt.bodVObdĺžniku(this,
				objekt.veľkosť() * 2.0 + veľkosť(),
				objekt.veľkosť() + veľkosť());
		}

		return super.koliduje(objekt);
	}

	@Override public boolean mimoHraníc(Bod[] poleBodov, double uhol)
	{
		if (polohaY() <= Svet.najmenšieY()) deaktivuj();
		else if (poleBodov[2].getY() == poleBodov[3].getY()) smer(360 - smer());
		else smer(180 - smer());

		if (smer() >= 175 && smer() <= 185) vľavo(25);
		else if (smer() <= 5 || smer() >= 355) vpravo(25);

		return true;
	}
}
