
import knižnica.*;
import java.util.TreeMap;

public class Minca extends GRobot
{
	private final static TreeMap<Integer, Obrázok> hodnoty = new TreeMap<>();

	private Obrázok dajObrázok(int hodnota)
	{
		Obrázok obrázok = hodnoty.get(hodnota);
		if (null == obrázok)
		{
			obrázok = new Obrázok(80, 80);
			kresliNaObrázok(obrázok);
			obrázok.trvanie(0.040);

			for (int i = 1; i < 15; ++i)
			{
				obrázok.vymaž();
				farba(svetložltá);
				kruh(veľkosť() + i);
				obrázok.rozmaž(i, 5, biela);
				kruh();
				farba(tmavožltá);
				text("" + hodnota);
				obrázok.pridajSnímku();
			}

			for (int i = 15; i > 1; --i)
			{
				obrázok.vymaž();
				farba(svetložltá);
				kruh(veľkosť() + i);
				obrázok.rozmaž(i, 5, biela);
				kruh();
				farba(tmavožltá);
				text("" + hodnota);
				obrázok.pridajSnímku();
			}

			kresliNaPodlahu();
			obrázok.spusti();
			hodnoty.put(hodnota, obrázok);
		}

		return obrázok;
	}

	private int hodnota;

	public Minca(int hodnota)
	{
		veľkosť(15);
		mierka(1);
		hodnota(hodnota);
	}

	public void hodnota(int hodnota)
	{
		this.hodnota = hodnota;
		vlastnýTvar(dajObrázok(hodnota));
	}

	public int hodnota()
	{
		return hodnota;
	}
}
